package org.sap;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import twitter4j.FilterQuery;
import twitter4j.StallWarning;
import twitter4j.Status;
import twitter4j.StatusDeletionNotice;
import twitter4j.StatusListener;
import twitter4j.TwitterStream;
import twitter4j.TwitterStreamFactory;
import twitter4j.conf.ConfigurationBuilder;
import twitter4j.TwitterException;
import org.sap.MessageHandler;

public class App {
    private static String CONSUMER_KEY = "";
    private static String CONSUMER_SECRET = "";
    private static String TOKEN = "";
    private static String TOKEN_SECRET = "";
    private static long[] follower_ids = {};
    
    private static String LIVELINK_APP_KEY = "";
    private static String LIVELINK_APP_SECRET = "";
    private static String BASE_URL = "";
    static Properties config;
    static MessageHandler handler;
            
    public static void main(String[] args) throws TwitterException, IOException {
        StatusListener listener = new StatusListener(){
            public void onStatus(Status status) {
                String message = status.getText();
                ArrayList<String> numbers = new ArrayList<String>();
                Enumeration<String> enums = (Enumeration<String>) config.propertyNames();
                while (enums.hasMoreElements()) {
                  String key = enums.nextElement();
                  String value = config.getProperty(key);
                  if(message.contains(key)){
                       numbers.add(config.getProperty(key));
                  }
                  if(numbers.size() > 0){
                    for (int i = 0; i < numbers.size(); i++) {
                        try {
                            handler.sendSMS(message, numbers.get(i), handler.getAccessToken(LIVELINK_APP_KEY, LIVELINK_APP_SECRET));
                        } catch (IOException ex) {
                            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                  }
                }
                System.out.println(status.getUser().getName() + " : " + status.getText()+ "  Tweeted AT: " + status.getCreatedAt());
            }         

            @Override
            public void onDeletionNotice(StatusDeletionNotice sdn) {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }

            @Override
            public void onTrackLimitationNotice(int i) {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }

            @Override
            public void onScrubGeo(long l, long l1) {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }

            @Override
            public void onException(Exception excptn) {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }

            @Override
            public void onStallWarning(StallWarning sw) {
                throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
            }
        };
        
        loadProperties();
        CONSUMER_KEY = config.getProperty("consumer_key");
        CONSUMER_SECRET = config.getProperty("consumer_secret");
        TOKEN = config.getProperty("access_token");
        TOKEN_SECRET = config.getProperty("access_token_secret");
        
        BASE_URL = config.getProperty("base_url");
        LIVELINK_APP_KEY = config.getProperty("app_key");
        LIVELINK_APP_SECRET = config.getProperty("app_secret");
        handler = new MessageHandler(BASE_URL);
        
        ConfigurationBuilder cb = new ConfigurationBuilder();
        cb.setOAuthConsumerKey(CONSUMER_KEY);
        cb.setOAuthConsumerSecret(CONSUMER_SECRET);
        cb.setOAuthAccessToken(TOKEN);
        cb.setOAuthAccessTokenSecret(TOKEN_SECRET);
        
        TwitterStreamFactory tf = new TwitterStreamFactory(cb.build());
        TwitterStream twitterStream = tf.getInstance();
        twitterStream.addListener(listener);
        
        FilterQuery query = new FilterQuery();
        query.follow(follower_ids);
        twitterStream.filter(query);        
    }
    
    public static void loadProperties(){
        config = new Properties();
	InputStream input = null;
        ClassLoader loader = Thread.currentThread().getContextClassLoader();
        
	try {
            input = loader.getResourceAsStream("config/config.properties");
            // load a properties file
            config.load(input);
	} catch (IOException ex) {
            ex.printStackTrace();
	} finally {
            if (input != null) {
                try {
                    input.close();
		} catch (IOException e) {
                    e.printStackTrace();
		}
            }
	}
    }
}